// This file was generated by gir (https://github.com/gtk-rs/gir)
// from
// from gir-files (https://github.com/gtk-rs/gir-files.git)
// DO NOT EDIT

use glib::{bitflags::bitflags, prelude::*, translate::*};
use std::fmt;

bitflags! {
    #[derive(Clone, Copy, Debug, PartialEq, Eq, Hash)]
    #[doc(alias = "DzlPropertiesFlags")]
    pub struct PropertiesFlags: u32 {
        #[doc(alias = "DZL_PROPERTIES_FLAGS_NONE")]
        const NONE = ffi::DZL_PROPERTIES_FLAGS_NONE as _;
        #[doc(alias = "DZL_PROPERTIES_FLAGS_STATEFUL_BOOLEANS")]
        const STATEFUL_BOOLEANS = ffi::DZL_PROPERTIES_FLAGS_STATEFUL_BOOLEANS as _;
    }
}

impl fmt::Display for PropertiesFlags {
    fn fmt(&self, f: &mut fmt::Formatter) -> fmt::Result {
        <Self as fmt::Debug>::fmt(self, f)
    }
}

#[doc(hidden)]
impl IntoGlib for PropertiesFlags {
    type GlibType = ffi::DzlPropertiesFlags;

    #[inline]
    fn into_glib(self) -> ffi::DzlPropertiesFlags {
        self.bits()
    }
}

#[doc(hidden)]
impl FromGlib<ffi::DzlPropertiesFlags> for PropertiesFlags {
    #[inline]
    unsafe fn from_glib(value: ffi::DzlPropertiesFlags) -> Self {
        skip_assert_initialized!();
        Self::from_bits_truncate(value)
    }
}

bitflags! {
    #[derive(Clone, Copy, Debug, PartialEq, Eq, Hash)]
    #[doc(alias = "DzlShortcutPhase")]
    pub struct ShortcutPhase: u32 {
        #[doc(alias = "DZL_SHORTCUT_PHASE_DISPATCH")]
        const DISPATCH = ffi::DZL_SHORTCUT_PHASE_DISPATCH as _;
        #[doc(alias = "DZL_SHORTCUT_PHASE_CAPTURE")]
        const CAPTURE = ffi::DZL_SHORTCUT_PHASE_CAPTURE as _;
        #[doc(alias = "DZL_SHORTCUT_PHASE_BUBBLE")]
        const BUBBLE = ffi::DZL_SHORTCUT_PHASE_BUBBLE as _;
        #[doc(alias = "DZL_SHORTCUT_PHASE_GLOBAL")]
        const GLOBAL = ffi::DZL_SHORTCUT_PHASE_GLOBAL as _;
    }
}

impl fmt::Display for ShortcutPhase {
    fn fmt(&self, f: &mut fmt::Formatter) -> fmt::Result {
        <Self as fmt::Debug>::fmt(self, f)
    }
}

#[doc(hidden)]
impl IntoGlib for ShortcutPhase {
    type GlibType = ffi::DzlShortcutPhase;

    #[inline]
    fn into_glib(self) -> ffi::DzlShortcutPhase {
        self.bits()
    }
}

#[doc(hidden)]
impl FromGlib<ffi::DzlShortcutPhase> for ShortcutPhase {
    #[inline]
    unsafe fn from_glib(value: ffi::DzlShortcutPhase) -> Self {
        skip_assert_initialized!();
        Self::from_bits_truncate(value)
    }
}

impl StaticType for ShortcutPhase {
    #[inline]
    #[doc(alias = "dzl_shortcut_phase_get_type")]
    fn static_type() -> glib::Type {
        unsafe { from_glib(ffi::dzl_shortcut_phase_get_type()) }
    }
}

impl glib::HasParamSpec for ShortcutPhase {
    type ParamSpec = glib::ParamSpecFlags;
    type SetValue = Self;
    type BuilderFn = fn(&str) -> glib::ParamSpecFlagsBuilder<Self>;

    fn param_spec_builder() -> Self::BuilderFn {
        Self::ParamSpec::builder
    }
}

impl glib::value::ValueType for ShortcutPhase {
    type Type = Self;
}

unsafe impl<'a> glib::value::FromValue<'a> for ShortcutPhase {
    type Checker = glib::value::GenericValueTypeChecker<Self>;

    #[inline]
    unsafe fn from_value(value: &'a glib::Value) -> Self {
        skip_assert_initialized!();
        from_glib(glib::gobject_ffi::g_value_get_flags(value.to_glib_none().0))
    }
}

impl ToValue for ShortcutPhase {
    #[inline]
    fn to_value(&self) -> glib::Value {
        let mut value = glib::Value::for_value_type::<Self>();
        unsafe {
            glib::gobject_ffi::g_value_set_flags(value.to_glib_none_mut().0, self.into_glib());
        }
        value
    }

    #[inline]
    fn value_type(&self) -> glib::Type {
        Self::static_type()
    }
}

impl From<ShortcutPhase> for glib::Value {
    #[inline]
    fn from(v: ShortcutPhase) -> Self {
        skip_assert_initialized!();
        ToValue::to_value(&v)
    }
}

bitflags! {
    #[derive(Clone, Copy, Debug, PartialEq, Eq, Hash)]
    #[doc(alias = "DzlTabStyle")]
    pub struct TabStyle: u32 {
        #[doc(alias = "DZL_TAB_ICONS")]
        const ICONS = ffi::DZL_TAB_ICONS as _;
        #[doc(alias = "DZL_TAB_TEXT")]
        const TEXT = ffi::DZL_TAB_TEXT as _;
        #[doc(alias = "DZL_TAB_BOTH")]
        const BOTH = ffi::DZL_TAB_BOTH as _;
    }
}

impl fmt::Display for TabStyle {
    fn fmt(&self, f: &mut fmt::Formatter) -> fmt::Result {
        <Self as fmt::Debug>::fmt(self, f)
    }
}

#[doc(hidden)]
impl IntoGlib for TabStyle {
    type GlibType = ffi::DzlTabStyle;

    #[inline]
    fn into_glib(self) -> ffi::DzlTabStyle {
        self.bits()
    }
}

#[doc(hidden)]
impl FromGlib<ffi::DzlTabStyle> for TabStyle {
    #[inline]
    unsafe fn from_glib(value: ffi::DzlTabStyle) -> Self {
        skip_assert_initialized!();
        Self::from_bits_truncate(value)
    }
}

impl StaticType for TabStyle {
    #[inline]
    #[doc(alias = "dzl_tab_style_get_type")]
    fn static_type() -> glib::Type {
        unsafe { from_glib(ffi::dzl_tab_style_get_type()) }
    }
}

impl glib::HasParamSpec for TabStyle {
    type ParamSpec = glib::ParamSpecFlags;
    type SetValue = Self;
    type BuilderFn = fn(&str) -> glib::ParamSpecFlagsBuilder<Self>;

    fn param_spec_builder() -> Self::BuilderFn {
        Self::ParamSpec::builder
    }
}

impl glib::value::ValueType for TabStyle {
    type Type = Self;
}

unsafe impl<'a> glib::value::FromValue<'a> for TabStyle {
    type Checker = glib::value::GenericValueTypeChecker<Self>;

    #[inline]
    unsafe fn from_value(value: &'a glib::Value) -> Self {
        skip_assert_initialized!();
        from_glib(glib::gobject_ffi::g_value_get_flags(value.to_glib_none().0))
    }
}

impl ToValue for TabStyle {
    #[inline]
    fn to_value(&self) -> glib::Value {
        let mut value = glib::Value::for_value_type::<Self>();
        unsafe {
            glib::gobject_ffi::g_value_set_flags(value.to_glib_none_mut().0, self.into_glib());
        }
        value
    }

    #[inline]
    fn value_type(&self) -> glib::Type {
        Self::static_type()
    }
}

impl From<TabStyle> for glib::Value {
    #[inline]
    fn from(v: TabStyle) -> Self {
        skip_assert_initialized!();
        ToValue::to_value(&v)
    }
}
